Bug 613046 - RFE: Add profile guided optimization to our builds of Python 3
RFE: Add profile guided optimization to our builds of Python 3
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: python3 (Show other bugs)
rawhide
All Linux
low Severity medium
: ---
: ---
Assigned To: Charalampos Stratakis
Fedora Extras Quality Assurance
:
Depends On: 613045
Blocks:
  Show dependency treegraph
 
Reported: 2010-07-09 11:30 EDT by Dave Malcolm
Modified: 2017-05-18 16:59 EDT (History)
7 users (show)

See Also:
Fixed In Version: python3-3.6.1-6.fc26 python3-3.5.3-6.fc25 python3-3.5.3-6.fc24
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: 613045
Environment:
Last Closed: 2017-05-14 16:18:36 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
Python 26359 None None None 2016-09-09 08:13 EDT

  None (edit)
Description Dave Malcolm 2010-07-09 11:30:59 EDT
+++ This bug was initially created as a clone of Bug #613045 +++

gcc 4.5 apparently adds "profile guided optimization", which, as I understand it uses information from previous runs of the DSOs to determine the relative frequency with which each branch is taken.

Python has a good benchmarking suite, which simulates real-world workloads.
See http://hg.python.org/benchmarks/
From the README.txt: "This project is intended to be an authoritative source of benchmarks for all 5 Python implementations. The focus is on real-world benchmarks, rather than 6 synthetic benchmarks, using whole applications when possible."

It may be worth integrating this into the build somehow.  It's not clear to me whether we can cache the data, or if we need to actually run the benchmarking suite during the build, then rebuild.

We should also use the benchmarking suite to measure performance, and see what impact pgo actually has.
Comment 1 Dave Malcolm 2010-07-09 11:33:23 EDT
See http://hg.python.org/benchmarks/file/tip/make_perf3.sh for a script that ports the suite to python 3.
Comment 2 Fedora Admin XMLRPC Client 2013-05-10 00:58:30 EDT
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 3 Fedora Admin XMLRPC Client 2015-05-12 08:01:39 EDT
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 4 Fedora Admin XMLRPC Client 2016-01-29 08:07:02 EST
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 5 Charalampos Stratakis 2016-09-09 08:13:58 EDT
A lot of thing are being refined currently upstream for that. With python 3.6, 3.5.3 and 2.7.13 a new configure flag will be added (--with-optimizations) which will enable the PGO along with other optimizations as well.
Comment 6 Fedora Update System 2017-05-09 14:48:19 EDT
python3-3.6.1-6.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-1e3062e0d6
Comment 7 Fedora Update System 2017-05-10 12:59:19 EDT
python3-3.5.3-6.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2017-0d1532b6af
Comment 8 Fedora Update System 2017-05-11 07:56:55 EDT
python3-3.5.3-6.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2017-830e540c85
Comment 9 Fedora Update System 2017-05-11 22:12:04 EDT
python3-3.6.1-6.fc26 has been pushed to the Fedora 26 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-1e3062e0d6
Comment 10 Fedora Update System 2017-05-12 09:35:56 EDT
python3-3.5.3-6.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-0d1532b6af
Comment 11 Fedora Update System 2017-05-12 18:35:01 EDT
python3-3.5.3-6.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-830e540c85
Comment 12 Fedora Update System 2017-05-14 16:18:36 EDT
python3-3.6.1-6.fc26 has been pushed to the Fedora 26 stable repository. If problems still persist, please make note of it in this bug report.
Comment 13 Fedora Update System 2017-05-15 00:36:17 EDT
python3-3.5.3-6.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.
Comment 14 Fedora Update System 2017-05-18 16:59:56 EDT
python3-3.5.3-6.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.